﻿/*
	Paintable Computing Simulation

	License

	This software (Paintable Computing Simulation and all parts of its 
	source code) is provided "as is", without any warranty and it is 
	the property of its respective authors. Use of this software is 
	free to everyone, except in commercial and/or military purposes 
	without written permission of its authors. Disassembling the 
	executable code of this software is forbidden for any purpose 
	without written permission of its authors.

	If you intend to use any part of the source code of this software 
	or to develop this software any further, you must include this 
	license in every source file and every About box, without changing 
	it; only appending the license is allowed. And if you use any part 
	of the source code of this software, or develop it further, please 
	send an e-mail to its authors.

	Authors of this software are not responsible for any consequences 
	which use of this software, use of any part of its source or its 
	further development may cause.

	All software and parts of source code used in the development of 
	this software are property of their respective owners.

	Good luck,
	Authors

	Authors (alphabetically):
	Fabijan Lukin
		fabijan@gmail.com
		fabijan.lukin@fer.hr
	Fran Pregernik
		fran.pregernik@gmail.com
		fran.pregernik@fer.hr
	Tomislav Sukser
		tomislav.sukser@gmail.com
		tomislav.sukser@zg.t-com.hr
		tomislav.sukser@fer.hr


	Note:
	Paintable computing was firstly introduced in Programming a 
	Paintable Computer written by William Joseph Butera.


    Copyright (c) 2005,2006. All rights reserved.
    4-6/2006

 */
using System;
using System.Collections;
using System.Drawing;
using System.Xml;

namespace PaintableSimulator.Engine.PaintableComputers.OperatingSystem
{
	/// <summary>
	/// 
	/// </summary>
	public class ExtendedProcessFragmentData
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="T:ExtendedProcessFragmentData"/> class.
		/// </summary>
		/// <param name="maximumNeighbourCount">The maximum neighbour count.</param>
		public ExtendedProcessFragmentData(uint maximumNeighbourCount)
		{
			queuedForTransfer = new BitArray((int) maximumNeighbourCount);
		}

		/// <summary>
		/// 
		/// </summary>
		private BitArray queuedForTransfer;

		/// <summary>
		/// 
		/// </summary>
		public bool IsQueuedForTransfer(int mirrorIndex)
		{
			return queuedForTransfer.Get(mirrorIndex);
		}

		/// <summary>
		/// 
		/// </summary>
		public void SetQueuedForTransferFlag(int mirrorIndex)
		{
			queuedForTransfer.Set(mirrorIndex, true);
		}

		/// <summary>
		/// 
		/// </summary>
		public void ResetQueuedForTransferFlag(int mirrorIndex)
		{
			queuedForTransfer.Set(mirrorIndex, false);
		}

		/// <summary>
		///     
		/// </summary>
		private uint subsequentUpdateFails;

		/// <summary>
		///     
		/// </summary>
		public uint SubsequentUpdateFails
		{
			get { return subsequentUpdateFails; }
			set { subsequentUpdateFails = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		private bool queuedForUnistall;

		/// <summary>
		/// 
		/// </summary>
		public bool QueuedForUninstall
		{
			get { return queuedForUnistall; }
			set { queuedForUnistall = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		private ProcessFragmentBase processFragment;

		/// <summary>
		/// 
		/// </summary>
		public ProcessFragmentBase ProcessFragment
		{
			get { return processFragment; }
			set { processFragment = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		private Type processFragmentType;

		/// <summary>
		/// 
		/// </summary>
		public Type ProcessFragmentType
		{
			get { return processFragmentType; }
			set { processFragmentType = value; }
		}

		/// <summary>
		/// 
		/// </summary>
		private uint originComputerId;

		/// <summary>
		/// 
		/// </summary>
		public uint OriginComputerId
		{
			get { return originComputerId; }
			set { originComputerId = value; }
		}

	}
}